#ifndef __bVIDEO_h
#define __bVIDEO_h

#include <cstdio>		/* sprintf */
#include <string>
#include <sys/ioctl.h>

extern int COLS, LINES;

extern class Video
{
private:
	int wx,wy;
	unsigned char TextAttr;
	void ShowCurs(const bool c);
	void GetScreenGeometry();
	void SetAttr(unsigned char n);
	struct termio back;
public:
	Video();
	~Video();

	void clear();
	
	Video &operator=(const unsigned char attr) { SetAttr(attr);return *this; }
	inline Video &operator << (const string &s) { return *this << s.c_str(); }
	Video &operator << (const int a)
	{ char Buf[10]; sprintf(Buf, "%d", a); return *this << Buf; }
	Video &operator << (const unsigned a)
	{ char Buf[10]; sprintf(Buf, "%u", a); return *this << Buf; }
	inline Video &operator << (const unsigned char c)
	{ return *this << (const char)c; }
	Video &operator << (const char *s)
	{
		while(*s)*this << *s++;
		return *this;
	}
	Video &operator << (const char c)
	{
		if(c=='\n')wx=1, wy++;
		else if(c!='\b')wx++;
		else if(wx>1)wx--;
		cout << c;
		return *this;
	}	
	
	inline void Flush() { cout << flush; }
	const unsigned char getkey(int wait=0);
	
	inline const int &wherey() { return wy; }
	inline const int &wherex() { return wx; }
	Video &Goto(int y, int x, const int v=-1);
	inline Video &Goto(const int y, const int x, const int v, int v1,int v2)
	{
		cout << "\33[?" << (v1 ? 2 : 6) << 'c';		
		v1=v1, v2=v2;
		return Goto(y,x,v);
	}
} video;

#endif	/* __bVIDEO_h */
